﻿// --------------------------------------------------------------------------------------------------------------------
// <summary>
//   This is the solution for the code challenge found on http://www.lantmateriet.se/knackkoden
// </summary>
// --------------------------------------------------------------------------------------------------------------------

namespace LantmaterietKnackkoden
{
    using System;
    using System.Security.Cryptography;
    using System.Text;

    public class Program
    {
        public static void Main()
        {
            const int NumberOfIterations = 10500;
            var sb = new StringBuilder();
            for (var i = 1; i <= NumberOfIterations; i++)
            {
                if (i % 3 != 0 && i % 5 != 0 && i % 7 != 0)
                {
                    sb.Append(i + " ");
                    continue;
                }

                if (i % 3 == 0 && i % 5 == 0 && i % 7 == 0)
                {
                    sb.Append("www.lantmateriet.se ");
                    continue;
                }

                if (i % 3 == 0)
                {
                    sb.Append("www. ");
                }
                else if (i % 5 == 0)
                {
                    sb.Append("lantmateriet ");
                }
                else if (i % 7 == 0)
                {
                    sb.Append(".se ");
                }
            }

            var resultString = sb.ToString().TrimEnd();
            if ("402087a86f4fbd5d01d80baec13fddc5" != GetMD5HashData(resultString, Encoding.UTF8))
            {
                Console.WriteLine("Error missmatch MD5 hash");
                return;
            }

            Console.WriteLine("The SHA1 hash is:" + GetSHA1HashData(resultString, Encoding.UTF8));
        }

        private static string GetMD5HashData(string data, Encoding encoding)
        {
            var md5 = MD5.Create();
            var hashData = md5.ComputeHash(encoding.GetBytes(data));
            var returnValue = new StringBuilder();
            foreach (var b in hashData)
            {
                returnValue.Append(b.ToString("x2").ToLower());
            }

            return returnValue.ToString();
        }

        private static string GetSHA1HashData(string data, Encoding encoding)
        {
            var sha1 = SHA1.Create();
            var hashData = sha1.ComputeHash(encoding.GetBytes(data));
            var returnValue = new StringBuilder();
            foreach (var b in hashData)
            {
                returnValue.Append(b.ToString("x2").ToLower());
            }

            return returnValue.ToString();
        }
    }
}
